
function initOverlay() {
  var menu = document.getElementById("contentAreaContextMenu");
  menu.addEventListener("popupshowing", contextPopupshowing, true);
}

function contextPopupshowing() {
  if(gContextMenu.onImage) {
        gContextMenu.showItem("context-firefusk", true);
  } else {
        gContextMenu.showItem("context-firefusk", gContextMenu.onSaveableLink);
  }
}

function populateMenu(menu, type, url) {

  if(url == "") {
          cmd = "prepData";
  } else {
        cmd = "firefusk";
  }

  var use = "10|20|50|100|200|500";

  
  var popup = document.createElement("menupopup");
  use = use.split("|");
  var i;

  for(i = 0; i < use.length; i++) {
    var item = document.createElement("menuitem");
    item.setAttribute("label", use[i]);
    item.setAttribute("oncommand", cmd + "('" + type + "'," + use[i] + ",'" + url +  "'); event.preventBubble();");
    popup.appendChild(item);
  }
  
  menu.appendChild(popup);
}

function isInt(q) {
    switch(q) {
        case '0' : return true;
        case '1' : return true;
        case '2' : return true;
        case '3' : return true;
        case '4' : return true;
        case '5' : return true;
        case '6' : return true;
        case '7' : return true;
        case '8' : return true;
        case '9' : return true;
    }
    
    return false;
}

function findDigits(q) {
    var numDigits = 0;
    for(i = q.length - 1; i >= 0; i--) {
        if( isInt(q[i]) )
            numDigits++;
        else
            return numDigits;
    }
    return numDigits;
}

function getLink() {
    return (gContextMenu.onImage) ? gContextMenu.imageURL :
        (gContextMenu.onSaveableLink) ? gContextMenu.linkURL() :
        null;
}

function prepData(type, span, url) {
    url = getLink();
    firefusk(type, span, url);
}

function ffManual() {
    url = prompt('enter url','');
    newDiv = _content.document.createElement("div");
    newDiv.id = "ffImage";
    newDiv.style.border = "solid 1px #ccc";
    newDiv.style.margin = "7px";
    newDiv.style.textAlign = "center";
    newDiv.style.position = "absolute";
    newDiv.style.backgroundColor = "#fff";
    newDiv.style.padding = "3px";
    newDiv.style.fontFamily = "helvetica, arial, sans-serif";
    newDiv.style.fontSize = "12px";
    
    closeBox = _content.document.createElement("div");
    closeBox.style.textAlign = "right";
    closeBox.style.margin = "0px";
    closeBox.style.padding = "0px";
    closeBox.style.backgroundColor = "#eee";
    closeBox.style.marginBottom = "7px;"
    closeBox.innerHTML = "<div style='float:left; margin-left: 1px; margin-top: 1px; text-align: left; width: 100px;'>Firefusk</div><a href='#' style='text-decoration: none; color: #999' onclick='this.parentNode.parentNode.parentNode.removeChild(this.parentNode.parentNode); return false;'>close</a>";
    newDiv.appendChild(closeBox);
    
    newImg = _content.document.createElement("img");
    if(url.substring(0, 7) == "http://") {
        newImg.src = url;
    } else {
        newImg.src = "http://" + url;
    }
    
    newImg.style.margin = "auto";
    newImg.style.marginBottom = "4px";
    newDiv.appendChild(newImg);
    temp = (window.innerHeight / 2) - (newImg.height) - 100;
    if(temp < 1) {
        newDiv.style.top = 0;
    } else {
        newDiv.style.top = temp;
    }
    temp = (window.innerWidth / 2) - (newImg.width) - 30;
    if(temp < 1) {
        newDiv.style.top = 0;
    } else {
        newDiv.style.left = temp;
    }
    newDiv.innerHTML = newDiv.innerHTML + "<br>" + url;

    _content.document.body.appendChild(newDiv);
    _content.document.location.href = _content.document.location.href + "#";
}

function firefusk(type, span, url) {
    var trueURL = url;
    var fromEnd = 0;
    var numDigits = 0;
    var extension = url.substring(url.lastIndexOf("."));
    var path = url.substring(0, url.lastIndexOf("/") + 1);
    url = url.substring(url.lastIndexOf("/") + 1, url.lastIndexOf("."));
    var tempURL = url;
    while(numDigits < 1 && tempURL.length > 0) {
        fromEnd++;
        numDigits = findDigits(tempURL);
        tempURL = tempURL.substr(0, tempURL.length - 1);
    }
    
    if(numDigits == 0) {
        alert("Can't find anything to increment in filename.");
        return false;
    }

    var engine = url.substring(0, url.length - fromEnd - numDigits + 1);
    var caboose = url.substring(url.length - fromEnd + 1);
    var digits = url.substring(url.length - fromEnd - numDigits + 1, url.length - fromEnd + 1);        
        
    var alpha, zed;
    
    switch(type) {
        case "plus" : 
            alpha = parseInt(digits, 10);
            zed = alpha + span;
            break;
        case "minus" : 
            zed = parseInt(digits, 10);
            alpha = zed - span;
            break;
        case "plusminus" : 
            alpha = parseInt(digits, 10) - span;
            zed = parseInt(digits, 10) + span;
            break;
    }
    
    if(alpha < 0) alpha = 0;
    var srcs = new Array(zed - alpha);
    var counter = 0;
    
    leading = document.getElementById("firefusk-leading").getAttribute("checked");

    for(i = alpha; i < zed + 1; i++) {
        var j = i.toString();
        while((j.length < numDigits) && leading) {
            j = "0" + j;
        }
        srcs[counter] = engine + j + caboose + extension + "\n";
        counter++;
    }

    tab = document.getElementById("firefusk-tab").getAttribute("checked");
    if(tab) {
        var ffTab = gBrowser.addTab("about:blank");
        //gBrowser.selectedTab = ffTab;
        ffBrowser = gBrowser.getBrowserForTab(ffTab);
        ffTarget = ffBrowser.contentWindow;
    } else {
        var ffTarget = window.open("about:blank");
    }
        
    ffTarget.document.writeln("<html>");
    ffTarget.document.writeln("<head>");
    ffTarget.document.write("<title>firefusk: " + path + srcs[0] + " - ");
    ffTarget.document.writeln(srcs[srcs.length - 1] + "</title>");
    ffTarget.document.writeln("<style> .error { display: none; } </style>");
    ffTarget.document.writeln("<style>");
    ffTarget.document.writeln("body { font-family: helvetica, verdana; text-align: center; font-size: 12px;}");
    ffTarget.document.writeln("a, a:hover, a:visited { color: #b33c04; text-decoration: none; } ");
    ffTarget.document.writeln(".wrap { text-align: center; float: left; padding: 3px; border: 1px solid #ccc; margin: 7px; }");
    ffTarget.document.writeln("img { margin: auto; }");
    ffTarget.document.writeln(".wrap img { margin-bottom: 4px; }"); 
    ffTarget.document.writeln(".error span { display: none; }");
    ffTarget.document.writeln("</style>");
    ffTarget.document.writeln("<script>");
    ffTarget.document.writeln("function change() {");
    ffTarget.document.writeln("    document.styleSheets[0].disabled = !document.styleSheets[0].disabled;");
    ffTarget.document.writeln("}");
    ffTarget.document.writeln("</script>");
    ffTarget.document.writeln("</head>");
    ffTarget.document.writeln("<body>");
    ffTarget.document.writeln("<img alt='firefusk' src='http://www.xoxosoma.com/code/firefusk/logo.gif?" + trueURL + "' />");
    ffTarget.document.writeln("<p>" + path + srcs[0] + " - " + srcs[srcs.length - 1] + "</p>");
    ffTarget.document.writeln("<p><a href='javascript:change()'>toggle broken links</a></p>");
    ffTarget.document.writeln("<p><a href='" + trueURL + "'>image link</a></p>");
    for(i = 0; i < srcs.length; i++) {
        ffTarget.document.writeln("<div class='wrap'>");
        ffTarget.document.writeln("<img onerror='this.parentNode.className=\"wrap error\"' alt='" + srcs[i] + "' src='" + path + srcs[i] + "' /><br />");
        ffTarget.document.writeln("<span>" + srcs[i] + "</span>");
        ffTarget.document.writeln("</div>");
    }
    ffTarget.document.writeln("</body>");
    ffTarget.document.writeln("</html>");
    ffTarget.document.close();
    putInstance(trueURL, "recent");
}

function populateInstance(source) {
  var use = getInstances(source);

  var theMenu = document.getElementById("firefusk-" + source);
  var popup = document.createElement("menupopup");
    
  if(use != null) {
  for(i = 0; i < use.length; i++) {
    var submenu = document.createElement("menu");
    submenu.setAttribute("label", use[i]);
    
    var subpopup = document.createElement("menupopup");
    
    var choice1 = document.createElement("menu");
    var choice2 = document.createElement("menu");
    var choice3 = document.createElement("menu");
    choice1.setAttribute("label","+/-");
    choice2.setAttribute("label","+");
    choice3.setAttribute("label","-");
    populateMenu(choice1,'plusminus',use[i]);
    populateMenu(choice2,'plus',use[i]);
    populateMenu(choice3,'minus',use[i]);
    
    subpopup.appendChild(choice1);
    subpopup.appendChild(choice2);
    subpopup.appendChild(choice3);
    
    var choice4 = document.createElement("menuitem");
    choice4.setAttribute("label","remove");
    choice4.setAttribute("oncommand","removeInstance('" + use[i] + "','" + source + "'), event.preventBubble();");
    subpopup.appendChild(choice4);

    if(source != "saved") {
        var choice5 = document.createElement("menuitem");
        choice5.setAttribute("label","save");
        choice5.setAttribute("oncommand","putInstance('" + use[i] + "','saved'), event.preventBubble();");
        subpopup.appendChild(choice5);
    }
    
    submenu.appendChild(subpopup);
    popup.appendChild(submenu);
  }
  }
  
  if(source == "saved") {
    var saveChoice = document.createElement("menuitem");
    saveChoice.setAttribute("label","save");
    saveChoice.setAttribute("oncommand","saveIt(); event.preventBubble();");
    popup.appendChild(saveChoice);
  } else if(use != null) {
    var removeChoice = document.createElement("menuitem");
    removeChoice.setAttribute("label","clear");
    removeChoice.setAttribute("oncommand","clearInstances('" + source + "'); event.preventBubble();");
    popup.appendChild(removeChoice);
  }
  
  theMenu.appendChild(popup);
  
}

function saveIt() {
    url = getLink();
    putInstance(url, "saved");
}

// destination - either saved or recent
function putInstance(q, destination) {
    try {
        var kept = getInstances(destination, 0);
        
        newKept = q;

        if(kept != null) {
          for(i = 0; i < kept.length; i++) {
                if(kept[i] == q) return; 
                newKept = newKept + "|%|" + kept[i];
            }
        }
        
    } catch(e) {
        newKept = q;
    }

    setPref(destination, newKept,  0);
}

function clearInstances(source) {
    setPref(source, null, 0);
}

function getInstances(source) {
    try {
        var kept = getPref(source, 0);
        kept = kept.split("|%|");
    } catch(e) {
        kept = null;
    }
    
    return kept;
}

function removeInstance(q, destination) {
    try {
        var kept = getInstances(destination, 0);
        
        if(kept != null) {
        
          if(kept[0] != q) {
            newKept = kept[0];
            if(kept[1] != q) {
                newKept = newKept + "|%|" + kept[1];
            }
          } else {
            newKept = kept[1];
          }
        
          for(i = 2; i < kept.length; i++) {
                if(kept[i] != q) newKept = newKept + "|%|" + kept[i];
            }
        }
        
    } catch(e) {
        newKept = null;
    }
    if(newKept == "") newKept = null;
    setPref(destination, newKept,  0);
}

function setPref(name, value, type) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    
    name = "extensions.firefusk." + name;
    
    if(value == null) {
        try {
           prefs.clearUserPref(name);
        } catch(e) {}
    } else {
        switch(type) {
            case 0: prefs.setCharPref(name, value); break;
            case 1: prefs.setIntPref(name, value); break;
            case 2: prefs.setBoolPref(name, value); break;
        }
    }
}

function getPref(name, type) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    
    name = "extensions.firefusk." + name;
    try {
         switch(type) {
            case 0: return prefs.getCharPref(name);
            case 1: return prefs.getIntPref(name); 
            case 2: return prefs.getBoolPref(name);
          }
    } catch(e) {
        return null;
    }    
}

window.addEventListener("load", initOverlay, false);